<template>
  <div class="dictTenantDtl">
    <el-button type="primary" @click="openModal">添加</el-button>
    <div class="content">
      <byTable
        :source="sourceList.data"
        :pagination="sourceList.pagination"
        :config="config"
        :loading="loading"
        highlight-current-row
        :hideSearch="true"
        @get-list="getList"
      >
        <template #slotName="{ item }">
          {{ item.createTime }}
        </template>
      </byTable>
    </div>
    <el-dialog
      :title="modalType == 'add' ? '新增' : '编辑'"
      v-model="dialogVisible"
      width="400"
      v-loading="loading"
    >
      <byForm
        :formConfig="formConfig"
        :formOption="formOption"
        v-model="formData.data"
        :rules="rules"
        ref="byform"
      >
      </byForm>
      <template #footer>
        <el-button @click="dialogVisible = false" size="large">取 消</el-button>
        <el-button
          type="primary"
          @click="submitForm('byform')"
          size="large"
          :loading="submitLoading"
        >
          确 定
        </el-button>
      </template>
    </el-dialog>
  </div>
</template>
    
  <script setup>
/* eslint-disable vue/no-unused-components */
import { ElMessage, ElMessageBox } from "element-plus";
import byTable from "@/components/byTable/index";
import byForm from "@/components/byForm/index";
import { computed, defineComponent, ref, watch } from "vue";
import { get } from "@vueuse/shared";
const { proxy } = getCurrentInstance();
const loading = ref(false);
const submitLoading = ref(false);
const dictCommonModal = ref(true);
defineProps({
  data: {
    type: Object,
    default: false,
  },
});
watch(proxy.data, (newValue, oldValue) => {
  getList();
});
const sourceList = ref({
  data: [],
  pagination: {
    total: 3,
    pageNum: 1,
    pageSize: 10,
  },
});
let dialogVisible = ref(false);
let roomDialogVisible = ref(false);
let modalType = ref("add");
let rules = ref({
  dictKey: [{ required: true, message: "请输入key", trigger: "blur" }],
  dictValue: [{ required: true, message: "请输入val", trigger: "blur" }],
  sort: [{ required: true, message: "请输入排序", trigger: "blur" }],
});

const selectConfig = computed(() => {
  return [
    {
      label: "状态",
      prop: "status",
      data: [
        {
          label: "禁用",
          value: "0",
        },
        {
          label: "启用",
          value: "1",
        },
      ],
    },
  ];
});
const config = computed(() => {
  return [
    {
      attrs: {
        label: "键",
        prop: "dictKey",
      },
    },
    {
      attrs: {
        label: "值",
        prop: "dictValue",
      },
    },
    {
      attrs: {
        label: "排序",
        prop: "sort",
      },
    },
    {
      attrs: {
        label: "操作",
        width: "200",
        align: "right",
      },
      // 渲染 el-button，一般用在最后一列。
      renderHTML(row) {
        if (row.type == 2) {
          return [
            {
              attrs: {
                label: "修改",
                type: "primary",
                text: true,
              },
              el: "button",
              click() {
                getDtl(row);
              },
            },
            {
              attrs: {
                label: "删除",
                type: "primary",
                text: true,
              },
              el: "button",
              click() {
                // 弹窗提示是否删除
                ElMessageBox.confirm("此操作将删除该数据, 是否继续?", "提示", {
                  confirmButtonText: "确定",
                  cancelButtonText: "取消",
                  type: "warning",
                }).then(() => {
                  // 删除
                  proxy
                    .post("/dictTenantData/delete", {
                      id: row.id,
                    })
                    .then((res) => {
                      ElMessage({
                        message: "删除成功",
                        type: "success",
                      });
                      getList();
                    });
                });
              },
            },
          ];
        }
      },
    },
  ];
});

let formData = reactive({
  data: {},
  treeData: [],
});
const formOption = reactive({
  inline: true,
  labelWidth: 100,
  itemWidth: 100,
  rules: [],
});
const byform = ref(null);
const treeData = ref([]);
const formConfig = computed(() => {
  return [
    {
      type: "input",
      prop: "dictKey",
      label: "键",
      required: true,
    },
    {
      type: "input",
      prop: "dictValue",
      label: "值",
    },
    {
      label: "排序",
      prop: "sort",
      type: "input",
      itemType: "number",
    },
  ];
});
const getList = async (req) => {
  console.log(proxy.data.data.code);
  sourceList.value.pagination = {
    ...sourceList.value.pagination,
    ...req,
    dictCode: proxy.data.data.code,
    tenantId: proxy.data.data.tenantId,
  };
  loading.value = true;
  proxy
    .post("/dictTenantData/page", sourceList.value.pagination)
    .then((message) => {
      sourceList.value.data = message.rows;
      sourceList.value.pagination.total = message.total;
      console.log(sourceList.value.data);
      setTimeout(() => {
        loading.value = false;
      }, 200);
    });
};
const openModal = () => {
  dialogVisible.value = true;
  modalType.value = "add";
  formData.data = {};
};

const submitForm = () => {
  console.log(byform.value);
  byform.value.handleSubmit((valid) => {
    submitLoading.value = true;
    formData.data.dictCode = proxy.data.data.code;
    formData.data.tenantId = proxy.data.data.tenantId;
    proxy
      .post("/dictTenantData/" + modalType.value, formData.data)
      .then((res) => {
        ElMessage({
          message: modalType.value == "add" ? "添加成功" : "编辑成功",
          type: "success",
        });
        dialogVisible.value = false;
        submitLoading.value = false;
        getList();
      })
      .catch((err) => {
        submitLoading.value = false;
      });
  });
};

const getDtl = (row) => {
  formData.data = { ...row };
  modalType.value = "edit";
  dialogVisible.value = true;
};

const changeStatus = (row) => {
  modalType.value = "edit";
  let status = row.status ? 0 : 1;
  proxy.post("/tenantInfo/detail", { id: row.id }).then((res) => {
    res.status = status;
    formData.data = res;
    ElMessageBox.confirm("你是否确认此操作?", "提示", {
      confirmButtonText: "确定",
      cancelButtonText: "取消",
      type: "warning",
    }).then(() => {
      // 删除
      proxy
        .post("/tenantInfo/" + modalType.value, formData.data)
        .then((res) => {
          ElMessage({
            message: "操作成功",
            type: "success",
          });
          getList();
        });
    });
  });
};
getList();
</script>
    
  <style lang="scss" scoped>
.dictTenantDtl {
}
.tenant {
  padding: 20px;
}
</style>